/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

function dibujar_fondo(){
	//Drawing the background according with the grid
	var i,j;
	for(i=0;i<GRID_ROWS;i++){
		for(j=0;j<GRID_COLUMNS;j++){
			if(grid.celdas[i][j]==1){
				contexto.drawImage(bandas.imagen, tam_image_square_x*j, tam_image_square_y*i, 
								tam_image_square_x, tam_image_square_y,
								TAM_GRID_SQUARE_X*j, TAM_GRID_SQUARE_Y*i, 
								TAM_GRID_SQUARE_X, TAM_GRID_SQUARE_Y);
			}
		}
	}
}

function dibujar_bandas(){

	if(fadein_alpha<=0){
		if(bandas.bandas.length>0){
			for(i=0;i<bandas.bandas.length;i++){
				if(bandas.bandas[i].alpha>0){
					contexto.save();
					if(bandas.bandas[i].alpha==1){
						contexto.shadowColor = "#666";
						contexto.shadowOffsetX = 3;
						contexto.shadowOffsetY = 3;
						contexto.shadowBlur = 3;
					}
					dibujar_banda(bandas.bandas[i],i);
					contexto.restore();
				}
			}
		}/*else{
			imprime_mensaje("NO TIENES BANDAS")
		}*/
	}
}

function dibujar_banda(banda,i){
	contexto.drawImage(bandas.marco_img, banda.x, banda.y, 150*banda.escala, 150*banda.escala);
	var text=banda.name;
	var text_width = contexto.measureText(text).width;
	if(banda.show_text){
		contexto.fillStyle = "#FFFFFF"; // Color del texto
		contexto.font = "bold 20px Comic Sans"; // Tamano y estilo de la fuente
		contexto.fillText(banda.name.obtener_texto(),banda.x+25,banda.y+50,150,100);
		/*if(banda.centrar)
			banda.name.dibujar(banda.x+30,banda.y+35);
		else
			banda.name.dibujar(0,0);*/			
	}
	contexto.closePath();

	if(banda.centrar){	
		//Dibujamos las opciones
		var j;
		for(j=0;j<bandas.opciones.length;j++)
			if(j==bandas.opcion_destacada)
				contexto.drawImage(bandas.opciones[j].over_image, bandas.opciones[j].x, bandas.opciones[j].y, bandas.opciones[j].w, bandas.opciones[j].h);
			else
				contexto.drawImage(bandas.opciones[j].image, bandas.opciones[j].x, bandas.opciones[j].y, bandas.opciones[j].w, bandas.opciones[j].h);

		//Dibujamos los miembros
		contexto.shadowOffsetX = 0;
		contexto.shadowOffsetY = 0;
		for(j=0;j<banda.members.length;j++){
            contexto.drawImage(banda.members[j].cara_img, banda.members[j].getXCara(),banda.members[j].getYCara(),banda.members[j].cara_w,banda.members[j].cara_h);
            contexto.drawImage(banda.members[j].cuerpo_img[0], banda.members[j].x, banda.members[j].y, banda.members[j].cuerpo_width, banda.members[j].cuerpo_height);
            if(j==bandas.bandas[bandas.banda_destacada].opcion_destacada)
				contexto.drawImage(banda.opciones[j].over_image, banda.opciones[j].x, banda.opciones[j].y, banda.opciones[j].w, banda.opciones[j].h);
			else
				contexto.drawImage(banda.opciones[j].image, banda.opciones[j].x, banda.opciones[j].y, banda.opciones[j].w, banda.opciones[j].h);
		}
	}		
}

function dibujar_botones(){
	if(boton_horario.apuntado)
		contexto.drawImage(boton_horario.over_image,boton_horario.x,boton_horario.y,boton_horario.w,boton_horario.h);
	else
		contexto.drawImage(boton_horario.image,boton_horario.x,boton_horario.y,boton_horario.w,boton_horario.h);
	
	if(boton_nueva_banda.apuntado)
		contexto.drawImage(boton_nueva_banda.over_image,boton_nueva_banda.x,boton_nueva_banda.y,boton_nueva_banda.w,boton_nueva_banda.h);
	else
		contexto.drawImage(boton_nueva_banda.image,boton_nueva_banda.x,boton_nueva_banda.y,boton_nueva_banda.w,boton_nueva_banda.h);
	
}

function dibujar_depurar(){
	
	contexto.save();
	//Showing the grid
	contexto.strokeStyle = '#F0F'; // Color
	for(i=0;i<GRID_ROWS;i++){
		contexto.beginPath();
		contexto.moveTo(0,TAM_GRID_SQUARE_Y*i);
		contexto.lineTo(ANCHURA_VENTANA,TAM_GRID_SQUARE_Y*i);
		contexto.closePath();
		contexto.stroke();
	}
	
	for(i=0;i<GRID_COLUMNS;i++){
		contexto.beginPath();
		contexto.moveTo(TAM_GRID_SQUARE_X*i,0);
		contexto.lineTo(TAM_GRID_SQUARE_X*i,ALTURA_VENTANA);
		contexto.closePath();
		contexto.stroke();
	}
	contexto.restore();
}

function dibujar_menu(){
    
    if(menu.estado==DESPLEGAR_MENU || menu.estado==REPLEGAR_MENU){        
        var i;
        for(i=0;i<menu.botones.length;i++){
			if(i==menu.boton_apuntado)
				contexto.drawImage(menu.botones[i].over_image, menu.botones[i].x, menu.y, menu.botones[i].w, menu.botones[i].h);
			else
				contexto.drawImage(menu.botones[i].image, menu.botones[i].x, menu.y, menu.botones[i].w, menu.botones[i].h);
        }
	}
}

function draw_fadein(){
	if(fadein_alpha>0.0){
		contexto.save();
		contexto.globalAlpha=fadein_alpha;
		contexto.fillStyle = "#000000";
		contexto.beginPath();
		contexto.rect(0, 0, ANCHURA_VENTANA, ALTURA_VENTANA);
		contexto.closePath();
		contexto.fill();
		fadein_alpha-=FADE_SPEED;
		contexto.restore();
		if(fadein_alpha<=0.0){
			//Inicializamos las bandas
			lanzar_bandas();
			desbloquear();
		}
	}
}

function draw_fadeout(){
	if(fadeout_alpha<1.0){
		contexto.save();
		contexto.globalAlpha=fadeout_alpha;
		contexto.fillStyle = "#000000";
		contexto.beginPath();
		contexto.rect(0, 0, ANCHURA_VENTANA, ALTURA_VENTANA);
		contexto.closePath();
		contexto.fill();
		fadeout_alpha+=FADE_SPEED;
		contexto.restore();
		if(fadeout_alpha>=1.0){
			contexto.globalAlpha=0.0;
			redireccionar(url_redireccionar);
		}
	}
}

function dibujar_dialogo(){
	if(dialogo.tag!=-1){
		contexto.save();
		
		//Definimos las sombras
		contexto.shadowOffsetX = 5;
		contexto.shadowOffsetY = 5;
		contexto.shadowBlur = 5;
		contexto.shadowColor = '#666';
		
		//Dibujamos el marco
		if(dialogo.alpha<1.0){
			contexto.globalAlpha=dialogo.alpha;
			dialogo.alpha+=0.1;
		}
		var gradiente = contexto.createRadialGradient(dialogo.x+dialogo.w/2, dialogo.y+dialogo.h/2, 20, dialogo.x+dialogo.w/2, dialogo.y+dialogo.h/2, 200);
		gradiente.addColorStop(0, "#8ED6FF");
		gradiente.addColorStop(1, "#004CB3");
		contexto.fillStyle = gradiente;
		contexto.beginPath();
		contexto.rect(dialogo.x, dialogo.y, dialogo.w, dialogo.h);
		contexto.closePath();
		contexto.fill();		
			
		//Dibujamos el mensaje de texto
		contexto.fillStyle = "#000000"; // Color del texto
		contexto.textBaseline = "top"; // Linea base del texto
		contexto.font = "bold 18px Comic Sans"; // Tamano y estilo de la fuente
		if(dialogo.tag==TAG_ELIMINAR_MIEMBRO)
			if(bandas.bandas[bandas.banda_destacada].members[bandas.bandas[bandas.banda_destacada].opcion_destacada].isUser)
				contexto.fillText("Deseas abandonar la banda?", dialogo.x+10, dialogo.y+10); // Pintamos el texto.
			else
				contexto.fillText("Eliminar a este miembro de la banda?", dialogo.x+10, dialogo.y+10); // Pintamos el texto.
		else if(dialogo.tag==TAG_ELIMINAR_BANDA)
			contexto.fillText("Deseas eliminar la banda?", dialogo.x+10, dialogo.y+10); // Pintamos el texto.
		
		//Dibujamos las opciones
		var i;
		for(i=0;i<dialogo.coordenadas_opciones.length;i++){
			var gradiente = contexto.createRadialGradient(dialogo.coordenadas_opciones[i][0], dialogo.coordenadas_opciones[i][1], 20,
															dialogo.coordenadas_opciones[i][0], dialogo.coordenadas_opciones[i][1], 300);		
			if(i==dialogo.opcion_apuntada){
				gradiente.addColorStop(0, "#F8FFAF");
				gradiente.addColorStop(1, "#6ED500");
			}else{
				gradiente.addColorStop(0, "#D6FF8E");
				gradiente.addColorStop(1, "#4CB300");
			}
			contexto.fillStyle = gradiente;

			contexto.beginPath();
			roundRect(dialogo.coordenadas_opciones[i][0], dialogo.coordenadas_opciones[i][1], dialogo.opcion_w, dialogo.opcion_h, 25);
			
			contexto.fill();
		}
		
		//Dibujamos el texto de las opciones
		contexto.fillStyle = "#000000"; // Color del texto
		contexto.fillText("Aceptar", dialogo.coordenadas_opciones[0][0]+15, dialogo.coordenadas_opciones[0][1]+13);
		contexto.fillText("Rechazar", dialogo.coordenadas_opciones[1][0]+15, dialogo.coordenadas_opciones[1][1]+13);

		contexto.restore();
	}
}