/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

window.onload = function() {
	
	canvas = document.getElementById("canvas");
	contexto = canvas.getContext("2d");
	
	depurar=0;
	boton_depurar = document.getElementById("boton_depurar"); //boton de depurar

	//Anadimos los listener para los eventos
	canvas.addEventListener('mouseup', raton_liberado, false);
	canvas.addEventListener('mousemove', raton_movido, false);
	canvas.addEventListener('mousedown', mouse_down, false);
	
	down=0;
	down_time=0;
	
	//Inicializamos el escenario
	grid=new Grid();
	//Inicializamos los miembros de todas las bandas
	miembros=new Miembros();
	//Inicializamos las bandas
	bandas=new Bandas();
	banda_centrada=0;

	//Inicializamos el boton del horario
	boton_horario=new Boton("boton_horario",25,ALTURA_VENTANA-85,50,50);
	//Inicializamos el boton de crear nueva banda
	boton_nueva_banda=new Boton("boton_nueva_banda",100,ALTURA_VENTANA-85,50,50);
	
	//Creamos el menu
	menu=new Menu(50,50,TAG_BANDS);
	menu_button_pointed=-1;
	
	//Inicializamos el dialogo
	dialogo=new Dialogo(0,0,0,0,-1);
	
	//Progreso de la carga
	var total=4+menu.botones.length*2;
	trozo=100/total;
	progreso=1;
	var i,j;
	for(i=0;i<menu.botones.length;i++){
		menu.botones[i].image.onload = function() {progreso+=trozo;}
		menu.botones[i].over_image.onload = function() {progreso+=trozo;}
	}
	bandas.imagen.onload = function() {
		progreso+=trozo;
		tam_image_square_x=bandas.imagen.width/GRID_COLUMNS;
		tam_image_square_y=bandas.imagen.height/GRID_ROWS;
	}
	bandas.marco_img.onload = function() {progreso+=trozo;}
	
	//Cargar cuerpos cuando haya mas de uno
	boton_horario.image.onload = function() {progreso+=trozo;}
	boton_horario.over_image.onload = function() {progreso+=trozo;}
	
	//Para lanzar el fadein
	fadein_alpha=1.0;
	//Para lanzar el fadeout
	fadeout_alpha=1.0;
	
	//Lanzamos el evento draw_progressbar
	interval=setInterval("run()",INTERVALO_REFRESCAR_PANTALLA);
	
	//Bloqueamos el control incialmente
	bloquear();	
}

function run(){
	animar();
	dibujar();
}

function animar(){	
	
	//Menu
	if(menu.estado==DESPLEGAR_MENU){
        if(menu.y<MAX_MENU_HIGHT)   menu.y++;
    }else if(menu.estado==REPLEGAR_MENU){
        if(menu.y>0){
            menu.y--;
        }else{
            menu.estado=MENU_INACTIVO;
			//Marcamos las casillas para no redibujarlas
			dibujar_fondo();
        }
    }
	
	//Tiempo que el raton se mantiene presionado
	if(down && down_time<MAX_DOWN_TIME){
		down_time++;
	}
	
	//
	for(i=0;i<bandas.bandas.length;i++){
		//Lanzar las bandas
		if(bandas.bandas[i].lanzar){
			if(bandas.bandas[i].crecer){
				bandas.bandas[i].escala+=bandas.bandas[i].velocidad_crecer;
				bandas.bandas[i].velocidad_crecer+=0.01;
				if(bandas.bandas[i].escala>=ESCALA_MAX_BANDAS){
					bandas.bandas[i].crecer=0;
					bandas.bandas[i].velocidad_crecer=0.02;
				}
			}else if(!bandas.bandas[i].crecer){
				if(bandas.bandas[i].escala>1){
					bandas.bandas[i].escala-=bandas.bandas[i].velocidad_crecer;
				}else{
					bandas.bandas[i].show_text=1;
					bandas.bandas[i].lanzar=0;
				}
			}
		}else if(bandas.bandas[i].centrar){ //Centramos la banda clickeada
			var distancia_x=Math.abs(CENTRAR_BANDA_X-bandas.bandas[i].x);
			bandas.bandas[i].velocidad_x=distancia_x/Math.abs(CENTRAR_BANDA_X-bandas.bandas[i].x_orig)*20;

			if(bandas.bandas[i].x<CENTRAR_BANDA_X){
				bandas.bandas[i].x+=bandas.bandas[i].velocidad_x;
			}else if(bandas.bandas[i].x>CENTRAR_BANDA_X){
				bandas.bandas[i].x-=bandas.bandas[i].velocidad_x;
			}			
			
			var distancia_y=Math.abs(CENTRAR_BANDA_Y-bandas.bandas[i].y);
			bandas.bandas[i].velocidad_y=distancia_y/Math.abs(CENTRAR_BANDA_Y-bandas.bandas[i].y_orig)*20;

			if(bandas.bandas[i].y<CENTRAR_BANDA_Y){
				bandas.bandas[i].y+=bandas.bandas[i].velocidad_y;
			}else if(bandas.bandas[i].y>CENTRAR_BANDA_Y){
				bandas.bandas[i].y-=bandas.bandas[i].velocidad_y;
			}
		}else if(bandas.bandas[i].descentrar){ //Descentramos la banda clickeada
			var distancia_x=Math.abs(bandas.bandas[i].x_orig-bandas.bandas[i].x);
			bandas.bandas[i].velocidad_x=distancia_x/Math.abs(CENTRAR_BANDA_X-bandas.bandas[i].x_orig)*20;
			
			if(bandas.bandas[i].x<bandas.bandas[i].x_orig){
				bandas.bandas[i].x+=bandas.bandas[i].velocidad_x;
			}else if(bandas.bandas[i].x>bandas.bandas[i].x_orig){
				bandas.bandas[i].x-=bandas.bandas[i].velocidad_x;
			}	
			
			var distancia_y=Math.abs(bandas.bandas[i].y_orig-bandas.bandas[i].y);
			bandas.bandas[i].velocidad_y=distancia_y/Math.abs(CENTRAR_BANDA_Y-bandas.bandas[i].y_orig)*20;

			if(bandas.bandas[i].y<bandas.bandas[i].y_orig){
				bandas.bandas[i].y+=bandas.bandas[i].velocidad_y;
			}else if(bandas.bandas[i].y>bandas.bandas[i].y_orig){
				bandas.bandas[i].y-=bandas.bandas[i].velocidad_y;
			}
		}
		
		if(bandas.bandas[i].desvanecer && bandas.bandas[i].alpha>0){
			bandas.bandas[i].alpha-=0.1;
		}else if(!bandas.bandas[i].desvanecer && bandas.bandas[i].alpha<1.0){
			bandas.bandas[i].alpha+=0.1;
		}
	}
}

function dibujar() {

	if(progreso<100){
		draw_progressbar(progreso);
	}else{

		dibujar_fondo();
		
		//Depuramos si hemos activado el modo depurar
		if(depurar){
			dibujar_depurar();
		}
		
		dibujar_bandas();
		dibujar_botones();
		
		dibujar_dialogo();
		dibujar_menu();
		
		draw_fadein();
		draw_fadeout();
	}
}

function activar_depurar(){
	depurar=!depurar;
	if(depurar){
		document.formulario.texto_banda.style.display="block";
		document.formulario.texto_user.style.display="block";
	
		imprime_mensaje("Modo depurar activado");
	}else{
		document.formulario.texto_banda.style.display="none";
		document.formulario.texto_user.style.display="none";
	
		imprime_mensaje("Modo depurar desactivado");
	}
}

function imprime_mensaje(mensaje){
	document.formulario.texto_mensaje.value=mensaje;
}

function lanzar_bandas(){
	for(i=0;i<bandas.bandas.length;i++)
		bandas.bandas[i].lanzar=1;
}

function destacar_bandas(x,y){
	bandas.banda_destacada=-1;
	for(i=0;i<bandas.bandas.length && bandas.banda_destacada==-1;i++){
		var x1=bandas.bandas[i].x;
		var y1=bandas.bandas[i].y;
		var x2=x1+200;
		var y2=y1+100;
		
		if(x>=x1 && x<=x2 && y>=y1 && y<=y2)
			bandas.banda_destacada=i;
	}
}

function destacar_opciones_banda(x,y){
	bandas.opcion_destacada=-1;
	for(i=0;i<bandas.opciones.length && bandas.opcion_destacada==-1;i++){
		var x1=bandas.opciones[i].x;
		var y1=bandas.opciones[i].y;
		var x2=x1+bandas.opciones[i].w;
		var y2=y1+bandas.opciones[i].h;
		
		if(x>=x1 && x<=x2 && y>=y1 && y<=y2)
			bandas.opcion_destacada=i;
	}
}

function destacar_opciones_miembro(x,y){
	bandas.bandas[bandas.banda_destacada].opcion_destacada=-1;
	for(i=0;i<bandas.bandas[bandas.banda_destacada].opciones.length && bandas.bandas[bandas.banda_destacada].opcion_destacada==-1;i++){
		var x1=bandas.bandas[bandas.banda_destacada].opciones[i].x;
		var y1=bandas.bandas[bandas.banda_destacada].opciones[i].y;
		var x2=x1+bandas.bandas[bandas.banda_destacada].opciones[i].w;
		var y2=y1+bandas.bandas[bandas.banda_destacada].opciones[i].h;
		
		if(x>=x1 && x<=x2 && y>=y1 && y<=y2)
			bandas.bandas[bandas.banda_destacada].opcion_destacada=i;
	}
}

function lanzar_dialogo(x,y,tag){
	dialogo=new Dialogo(x,y,300,200,tag);
	//grid.mark_grid_area(x,y,x+300,y+200);
}

function bloquear(){blok=1;}
function desbloquear(){blok=0;}