/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

function dibujar_fondo(){
	//Drawing the background according with the grid
	var i,j;
	for(i=0;i<GRID_ROWS;i++){
		for(j=0;j<GRID_COLUMNS;j++){
			if(grid.celdas[i][j]==1){
				contexto.drawImage(escenario.fondo, tam_image_square_x*j, tam_image_square_y*i, 
								tam_image_square_x, tam_image_square_y,
								TAM_GRID_SQUARE_X*j, TAM_GRID_SQUARE_Y*i, 
								TAM_GRID_SQUARE_X, TAM_GRID_SQUARE_Y);
			}
		}
	}
}

function dibujar_banda(){
	var i;
	for(i=0;i<banda.miembros.length;i++){
		contexto.drawImage(banda.miembros[i].cara_img, banda.miembros[i].getXCara(),banda.miembros[i].getYCara(),banda.miembros[i].cara_w,banda.miembros[i].cara_h);
		contexto.drawImage(banda.miembros[i].cuerpo_img[0], banda.miembros[i].x, banda.miembros[i].y, banda.miembros[i].cuerpo_width, banda.miembros[i].cuerpo_height);
		contexto.save();
		contexto.translate(banda.instrumentos[i].x, banda.instrumentos[i].y);
		contexto.rotate(Math.PI/3);
		contexto.drawImage(banda.instrumentos[i].objeto_img,0,0,banda.instrumentos[i].width,banda.instrumentos[i].height)
		contexto.restore();
	}
}

function dibujar_publico(){
	var i;
	for(i=0;i<publico.publico.length;i++){
		contexto.drawImage(publico.publico[i].cara_img, publico.publico[i].getXCara(),publico.publico[i].getYCara(),publico.publico[i].cara_w,publico.publico[i].cara_h);
		contexto.drawImage(publico.publico[i].cuerpo_img[0], publico.publico[i].x, publico.publico[i].y, publico.publico[i].cuerpo_width, publico.publico[i].cuerpo_height);
	}
}

function dibujar_depurar(){
	
	contexto.save();
	//Showing the grid
	contexto.strokeStyle = '#F0F'; // Color
	for(i=0;i<GRID_ROWS;i++){
		contexto.beginPath();
		contexto.moveTo(0,TAM_GRID_SQUARE_Y*i);
		contexto.lineTo(ANCHURA_VENTANA,TAM_GRID_SQUARE_Y*i);
		contexto.closePath();
		contexto.stroke();
	}
	
	for(i=0;i<GRID_COLUMNS;i++){
		contexto.beginPath();
		contexto.moveTo(TAM_GRID_SQUARE_X*i,0);
		contexto.lineTo(TAM_GRID_SQUARE_X*i,ALTURA_VENTANA);
		contexto.closePath();
		contexto.stroke();
	}
	contexto.restore();
}

function draw_fadein(){
	if(fadein_alpha>0.0){
		contexto.save();
		contexto.globalAlpha=fadein_alpha;
		contexto.fillStyle = "#000000";
		contexto.beginPath();
		contexto.rect(0, 0, ANCHURA_VENTANA, ALTURA_VENTANA);
		contexto.closePath();
		contexto.fill();
		fadein_alpha-=FADE_SPEED;
		contexto.restore();
		if(fadein_alpha<=0.0){
			var i;
			for(i=0;i<banda.instrumentos.length;i++)
				banda.instrumentos[i].actualizar_dimensiones();
			desbloquear();
		}
	}
}

function draw_fadeout(){
	if(fadeout_alpha<1.0){
		contexto.save();
		contexto.globalAlpha=fadeout_alpha;
		contexto.fillStyle = "#000000";
		contexto.beginPath();
		contexto.rect(0, 0, ANCHURA_VENTANA, ALTURA_VENTANA);
		contexto.closePath();
		contexto.fill();
		fadeout_alpha+=FADE_SPEED;
		contexto.restore();
		if(fadeout_alpha>=1.0){
			contexto.globalAlpha=0.0;
			redireccionar(url_redireccionar);
		}
	}
}

function dibujar_dialogo(){
	if(dialogo.tag!=-1){
		contexto.save();
		
		//Definimos las sombras
		contexto.shadowOffsetX = 5;
		contexto.shadowOffsetY = 5;
		contexto.shadowBlur = 5;
		contexto.shadowColor = '#666';
		
		//Dibujamos el marco
		if(dialogo.alpha<1.0){
			contexto.globalAlpha=dialogo.alpha;
			dialogo.alpha+=0.1;
		}
		var gradiente = contexto.createRadialGradient(dialogo.x+dialogo.w/2, dialogo.y+dialogo.h/2, 20, dialogo.x+dialogo.w/2, dialogo.y+dialogo.h/2, 200);
		gradiente.addColorStop(0, "#8ED6FF");
		gradiente.addColorStop(1, "#004CB3");
		contexto.fillStyle = gradiente;
		contexto.beginPath();
		contexto.rect(dialogo.x, dialogo.y, dialogo.w, dialogo.h);
		contexto.closePath();
		contexto.fill();		
			
		//Dibujamos el mensaje de texto
		contexto.fillStyle = "#000000"; // Color del texto
		contexto.textBaseline = "top"; // Linea base del texto
		contexto.font = "bold 18px Comic Sans"; // Tamano y estilo de la fuente
		contexto.fillText("Eliminar a este miembro de la banda?", dialogo.x+10, dialogo.y+10); // Pintamos el texto.
		
		//Dibujamos las opciones
		var i;
		for(i=0;i<dialogo.coordenadas_opciones.length;i++){
			var gradiente = contexto.createRadialGradient(dialogo.coordenadas_opciones[i][0], dialogo.coordenadas_opciones[i][1], 20,
															dialogo.coordenadas_opciones[i][0], dialogo.coordenadas_opciones[i][1], 300);		
			if(i==dialogo.opcion_apuntada){
				gradiente.addColorStop(0, "#F8FFAF");
				gradiente.addColorStop(1, "#6ED500");
			}else{
				gradiente.addColorStop(0, "#D6FF8E");
				gradiente.addColorStop(1, "#4CB300");
			}
			contexto.fillStyle = gradiente;

			contexto.beginPath();
			roundRect(dialogo.coordenadas_opciones[i][0], dialogo.coordenadas_opciones[i][1], dialogo.opcion_w, dialogo.opcion_h, 25);
			
			contexto.fill();
		}
		
		//Dibujamos el texto de las opciones
		contexto.fillStyle = "#000000"; // Color del texto
		contexto.fillText("Aceptar", dialogo.coordenadas_opciones[0][0]+15, dialogo.coordenadas_opciones[0][1]+13);
		contexto.fillText("Rechazar", dialogo.coordenadas_opciones[1][0]+15, dialogo.coordenadas_opciones[1][1]+13);

		contexto.restore();
	}
}